#!/usr/bin/perl

# jcorrect web interface: '09/03/11, by KGK

# begin customizing variables
my $nkf = '/usr/bin/nkf';
my $jcorrect = '/usr/local/bin/jcorrect';
my $tmp = "/tmp/jcorrect$$";

my $title = 'jcorrect --- A simple Japanese grammer checker';
my $tips_url = 'http://www.ispl.jp/~oosaki/research/tips-jcorrect/';
my $tips_title = 'Tips for proofreading with jcorrect (in Japanese)';
# end customizing variables

use CGI;
use CGI::Carp qw(fatalsToBrowser);
$CGI::POST_MAX = 1024 * 1024;

my $q = new CGI;

$q->param;
die($q->cgi_error) if ($q->cgi_error);

my $a1 = $q->param('a1');

$title .= ' (result)' if $a1;

print $q->header(-charset=>'x-euc-jp');
print $q->start_html(-title => $title, -charset => 'x-euc-jp',
		     -encoding => 'x-euc-jp', -lang => 'ja-JP');
print "\n";

if ($a1) {
    # normalize commas and periods
    $a1 =~ s/\.(\W)/$1/g;
    $a1 =~ s/\.$//g;
    $a1 =~ s/,\s?//g;

    $ENV{'PATH'} = "/usr/local/bin:" . $ENV{'PATH'};
    
    open(TMP, ">$tmp");
    print TMP $a1;
    close(TMP);
    my $result = `$nkf -e $tmp | $jcorrect`;
    $result =~ s/&/&amp;/g;
    $result =~ s/</&lt;/g;
    $result =~ s/>/&gt;/g;
    $result =~ s/"/&quot;/g; #"
    print $q->pre($q->code($result));
    unlink $tmp;
} else {
    print $q->h1($title), "\n";
    print $q->p("Type Japanese text in the following textarea,",
		"and press the [submit] button.\nRefer to",
		$q->a({href => $tips_url}, $tips_title),
		"for introduction of jcorrect."), "\n";
    print $q->start_p;
    print $q->start_form(-action => $q->url);
    print $q->textarea(-name => "a1", -rows => 25, -cols => 80), "\n";
    print $q->submit, $q->reset;
    print $q->end_p;
    print $q->end_form, "\n";
}

print "\n";
print $q->end_html, "\n";

# end
